
#include <mcp_can.h>
#include <SPI.h>

uint8_t RearHitch;

unsigned long Time;

long unsigned int rxId;
unsigned char len = 0;
unsigned char rxBuf[8];

MCP_CAN CAN0(10);                          // Set CS to pin 10

void setup()
{
  Serial.begin(115200);
  
  if(CAN0.begin(MCP_STDEXT, CAN_250KBPS, MCP_16MHZ) == CAN_OK) Serial.print("MCP2515 Init Okay!!\r\n");
  else Serial.print("MCP2515 Init Failed!!\r\n");
  
  pinMode(2, INPUT);                    // Setting pin 2 for /INT input

  CAN0.init_Mask(0,1,0xFFFFFF);         // Init first mask... 
  CAN0.init_Filt(0,1,0x0CFE45F0);       // Init first filter...  
  CAN0.init_Filt(1,1,0x0CFE45F0);
  
  CAN0.init_Mask(1,1,0xFFFFFF);         // Init second mask... 
  CAN0.init_Filt(2,1,0x0CFE45F0);       // Init third filter...
  CAN0.init_Filt(3,1,0x0CFE45F0);       // Init fouth filter...
  CAN0.init_Filt(4,1,0x0CFE45F0);       // Init fifth filter...
  CAN0.init_Filt(5,1,0x0CFE45F0);       // Init sixth filter...
  
  Serial.println("MCP2515 Library Mask & Filter Example...");
  
  CAN0.setMode(MCP_NORMAL);                // Change to normal mode to allow messages to be transmitted
}

void loop()
{
    if(!digitalRead(2))                    // If pin 2 is low, read receive buffer
    {
      Time = millis();
      Serial.print(Time);
      Serial.print(", ");
      
      CAN0.readMsgBuf(&rxId, &len, rxBuf); // Read data: len = data length, buf = data byte(s)
      Serial.print("ID: ");
      Serial.print(rxId, HEX);
      Serial.print(" Data: ");
      for(int i = 0; i<len; i++)           // Print each byte of the data
      {
        Serial.print(rxBuf[i], DEC);
        Serial.print(", ");
      }

      Serial.print(" Hitch = ");
      RearHitch = (rxBuf[0] * 0.4);
      Serial.print(RearHitch);
      Serial.print("%");

      if (bitRead(rxBuf[1],6) == 1) Serial.print(" In Work");    
      else Serial.print(" Out of Work");    
      
      Serial.println();
    }

}
